commit:     3fb7f7dc46c8c7703439aacf1be18eca8f99d44e
Author:     Matthew Smith <matthew <AT> gentoo <DOT> org>
AuthorDate: Fri Sep  9 09:02:07 2022 +0000
Commit:     Matthew Smith <matthew <AT> gentoo <DOT> org>
CommitDate: Fri Sep  9 09:47:00 2022 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=3fb7f7dc

sys-devel/mold: add 1.4.2

Signed-off-by: Matthew Smith <matthew <AT> gentoo.org>

 sys-devel/mold/Manifest          |  1 +
 sys-devel/mold/mold-1.4.2.ebuild | 92 ++++++++++++++++++++++++++++++++++++++++
 2 files changed, 93 insertions(+)

diff --git a/sys-devel/mold/Manifest b/sys-devel/mold/Manifest
index bcde82ba97a1..f0d576a1e727 100644
--- a/sys-devel/mold/Manifest
+++ b/sys-devel/mold/Manifest
@@ -1 +1,2 @@
 DIST mold-1.4.1.tar.gz 6280266 BLAKE2B 
60d0a876e0bcc8f644e4b6fffe0de14299bf2bd6e382869c87761d725dca6efa874cac37aaf94ad85038c5a24521ed3582782be943236ab81c2e4b66e6002f5e
 SHA512 
304caf4e9d9b24170a9442a84036790407bd02609a5d07c31e5f0f6285128099cbc962571804636a5da55afda59b447c12218f9e4d402fbfa55ebc354814bdda
+DIST mold-1.4.2.tar.gz 6287845 BLAKE2B 
ec429f70b92c4af5be83761893028f2324fe2086fea0e9b64f1d89884c6bc8dd34e5615178ef28ff19c36d01dafc834e6f6b9a8d701d62e360ef4e0be2f065bd
 SHA512 
17f543969e53737818b0be563aee39feac672f93e0fd712827523232b64eccb4629f3994c5a90de50b5f761886669e0946a8d463663725e774eb7d352de1ced1

diff --git a/sys-devel/mold/mold-1.4.2.ebuild b/sys-devel/mold/mold-1.4.2.ebuild
new file mode 100644
index 000000000000..1a83cf4d004e
--- /dev/null
+++ b/sys-devel/mold/mold-1.4.2.ebuild
@@ -0,0 +1,92 @@
+# Copyright 2021-2022 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=8
+
+inherit cmake toolchain-funcs
+
+DESCRIPTION="A Modern Linker"
+HOMEPAGE="https://github.com/rui314/mold";
+if [[ ${PV} == 9999 ]] ; then
+       EGIT_REPO_URI="https://github.com/rui314/mold.git";
+       inherit git-r3
+else
+       SRC_URI="https://github.com/rui314/mold/archive/refs/tags/v${PV}.tar.gz 
-> ${P}.tar.gz"
+       KEYWORDS="~amd64 ~riscv"
+fi
+
+# mold (AGPL-3)
+#  - xxhash (BSD-2)
+#  - tbb (Apache-2.0)
+LICENSE="AGPL-3 Apache-2.0 BSD-2"
+SLOT="0"
+IUSE="system-tbb"
+
+RDEPEND="
+       sys-libs/zlib
+       system-tbb? ( >=dev-cpp/tbb-2021.4.0:= )
+       !kernel_Darwin? (
+               >=dev-libs/mimalloc-2:=
+               dev-libs/openssl:=
+       )
+"
+DEPEND="${RDEPEND}"
+
+PATCHES=(
+       # https://bugs.gentoo.org/865837
+       "${FILESDIR}"/mold-1.4.1-tbb-flags-stripping.patch
+)
+
+pkg_pretend() {
+       # Requires a c++20 compiler, see #831473
+       if [[ ${MERGE_TYPE} != binary ]]; then
+               if tc-is-gcc && [[ $(gcc-major-version) -lt 10 ]]; then
+                       die "${PN} needs at least gcc 10"
+               elif tc-is-clang && [[ $(clang-major-version) -lt 12 ]]; then
+                       die "${PN} needs at least clang 12"
+               fi
+       fi
+}
+
+src_prepare() {
+       cmake_src_prepare
+
+       # Needs unpackaged dwarfdump
+       rm test/elf/{{dead,compress}-debug-sections,compressed-debug-info}.sh 
|| die
+
+       # Heavy tests, need qemu
+       rm test/elf/gdb-index-{compress-output,dwarf{2,3,4,5}}.sh || die
+       rm test/elf/lto-{archive,dso,gcc,llvm,version-script}.sh || die
+
+       # Sandbox sadness
+       rm test/elf/run.sh || die
+       sed -i 's|`pwd`/mold-wrapper.so|"& ${LD_PRELOAD}"|' \
+               test/elf/mold-wrapper{,2}.sh || die
+
+       # static-pie tests require glibc built with static-pie support
+       if ! has_version -d 'sys-libs/glibc[static-pie(+)]'; then
+               rm test/elf/{,ifunc-}static-pie.sh || die
+       fi
+}
+
+src_configure() {
+       local mycmakeargs=(
+               -DMOLD_ENABLE_QEMU_TESTS=OFF
+               -DMOLD_LTO=OFF # Should be up to the user to decide this with 
CXXFLAGS.
+               -DMOLD_USE_SYSTEM_MIMALLOC=ON
+               -DMOLD_USE_SYSTEM_TBB=$(usex system-tbb)
+       )
+       cmake_src_configure
+}
+
+src_install() {
+       dobin "${BUILD_DIR}"/${PN}
+       dolib.so "${BUILD_DIR}"/${PN}-wrapper.so
+
+       dodoc docs/{design,execstack}.md
+       doman docs/${PN}.1
+
+       dosym ${PN} /usr/bin/ld.${PN}
+       dosym ${PN} /usr/bin/ld64.${PN}
+       dosym ../../../usr/bin/${PN} /usr/libexec/${PN}/ld
+}

Reply via email to